#ifndef _PCI8620_DEVICE_
#define _PCI8620_DEVICE_
//#################### ADӲPCI8620_PARA_AD #####################
// ADʵӲ
typedef struct _PCI8620_PARA_AD     
{
	LONG ADMode;            // ADģʽѡ(/鷽ʽ)
	LONG FirstChannel;      // ͨ[0,15]
	LONG LastChannel;       // ĩͨ[0,15],Ҫĩͨڻͨ
	LONG Frequency;         // ɼƵ,λΪHz, [31, 250000]
	LONG GroupInterval;     // ʱ(λ΢)[1, 419430]
	LONG LoopsOfGroup;	    // ѭ[1, 65535]
	LONG Gains;				// 
	LONG InputRange;		// ģ̷Χ
	LONG TriggerMode;       // ģʽѡ
	LONG TriggerSource;		// Դѡ
	LONG TrigLevelVolt;		// ƽ(0~10000mV)
	LONG TriggerType;		// 
	LONG TriggerDir;		// ѡ(/򴥷)
	LONG ClockSource;		// ʱԴѡ(/ʱԴ)
	LONG bClockOutput;      // ʱ
	LONG GroundingMode;		// ӵģʽ
} PCI8620_PARA_AD, *PPCI8620_PARA_AD;

//***********************************************************
// ADӲPCI8620_PARA_ADеADModeʹùģʽѡ
const long PCI8620_ADMODE_SEQUENCE		= 0x00; // 
const long PCI8620_ADMODE_GROUP			= 0x01; // 

//***********************************************************
// ADӲPCI8620_PARA_ADеInputRangeģ뷶Χʹõѡ
const long PCI8620_INPUT_N10000_P10000mV= 0x00; // 10000mV
const long PCI8620_INPUT_N5000_P5000mV	= 0x01; // 5000mV
const long PCI8620_INPUT_N2500_P2500mV	= 0x02; // 2500mV
const long PCI8620_INPUT_0_P10000mV		= 0x03; // 010000mV

//***********************************************************
// ADPCI8620_PARA_ADеGainsʹõӲѡ
const long PCI8620_GAINS_1MULT			= 0x00; // 1
const long PCI8620_GAINS_2MULT			= 0x01; // 2
const long PCI8620_GAINS_4MULT			= 0x02; // 4
const long PCI8620_GAINS_8MULT			= 0x03; // 8

//***********************************************************
// ADӲPCI8620_PARA_ADеTriggerModeԱʹôģʽѡ
const long PCI8620_TRIGMODE_SOFT		= 0x00; // (ڴ)
const long PCI8620_TRIGMODE_POST		= 0x01; // Ӳ(ⴥ)

//***********************************************************
// ADӲPCI8620_PARA_ADеTriggerSourceԴźʹõѡ
const long PCI8620_TRIGSRC_ATR			= 0x00; // ѡⲿATRΪԴ
const long PCI8620_TRIGSRC_DTR			= 0x01; // ѡⲿDTRΪԴ

// ADӲPCI8620_PARA_ADеTriggerTypeʹõѡ
const long PCI8620_TRIGTYPE_EDGE		= 0x00; // ش
const long PCI8620_TRIGTYPE_PULSE		= 0x01; // ƽ

//***********************************************************
// ADӲPCI8620_PARA_ADеTriggerDirʹõѡ
const long PCI8620_TRIGDIR_NEGATIVE		= 0x00; // 򴥷(͵ƽ/½ش)
const long PCI8620_TRIGDIR_POSITIVE		= 0x01; // 򴥷(ߵƽ/ش)
const long PCI8620_TRIGDIR_POSIT_NEGAT	= 0x02; // 򴥷(/͵ƽ/½ش)

//***********************************************************
// ADӲPCI8620_PARA_ADеClockSourceʱԴʹõѡ
const long PCI8620_CLOCKSRC_IN			= 0x00; // ڲʱ
const long PCI8620_CLOCKSRC_OUT			= 0x01; // ⲿʱ

// ADӲPCI8620_PARA_ADеbClockOutputԱʹڲⲿʱԴѡ
const long PCI8620_CLOCKOUT_DISABLE		= 0x00; // ֹϵԴʱ
const long PCI8620_CLOCKOUT_ENABLE		= 0x01; // ϵԴʱ

//***********************************************************
// AD(PCI8620_PARA_AD)еGroundingModeʹõģźŽӵطʽѡ
const long PCI8620_GNDMODE_SE			= 0x00;	// ˷ʽ(SE:Single end)
const long PCI8620_GNDMODE_DI			= 0x01;	// ˫˷ʽ(DI:Differential)

//*************************************************************************************
// ADʵӲ
typedef struct _PCI8620_STATUS_AD     
{
	LONG bNotEmpty;			// FIFO洢ķǿձ־=TRUEǿգ = FALSE 
	LONG bHalf;				// FIFO洢İ־=TRUEϣ = FALSE 
	LONG bOverflow;			// FIFO洢־= TRUEѷ = FALSEδ
} PCI8620_STATUS_AD, *PPCI8620_STATUS_AD;

const int PCI8620_MAX_SEGMENT_COUNT = 64;
typedef struct _PCI8620_STATUS_DMA     
{
	LONG iCurSegmentID;								// ǰλID,ʾDMAڴĻ
	LONG bSegmentSts[PCI8620_MAX_SEGMENT_COUNT];	// ¾״̬,=1ʾӦΪ,Ϊ
	LONG bBufferOverflow;							// ״̬
} PCI8620_STATUS_DMA, *PPCI8620_STATUS_DMA;

//***********************************************************
// DAWriteDeviceDAģΧOutputRangeʹõѡ
const long PCI8620_OUTPUT_0_P5000mV			= 0x00;		// 05000mV
const long PCI8620_OUTPUT_0_P10000mV		= 0x01;		// 010000mV
const long PCI8620_OUTPUT_0_P10800mV		= 0x02;		// 010800mV
const long PCI8620_OUTPUT_N5000_P5000mV		= 0x03;		// 5000mV
const long PCI8620_OUTPUT_N10000_P10000mV	= 0x04;		// 10000mV
const long PCI8620_OUTPUT_N10800_P10800mV	= 0x05;		// 10800mV

//***********************************************************
// ڼCNTĲ
// ӲControlModeģʽѡ
const long PCI8620_GATEMODE_POSITIVE_0	= 0x00;		// COUNTER:GATEߵƽʱ͵ƽʱֹͣʱдֵֵ
													// жϣдֵʼʱOUTʼΪ00ʱOUTΪ1

const long PCI8620_GATEMODE_RISING_1	= 0x01;		// COUNTER:GATEϱشгGATEװֵ
													// ɱ̵壺дֵʱOUTΪ1ʼʱOUTΪ00ʱOUTٴΪ1

const long PCI8620_GATEMODE_POSITIVE_2	= 0x02;		// COUNTER:GATEߵƽʱ͵ƽʱֹͣʱдֵֵ
													// ƵʷڼOUTΪ10һڵ0װֵ

const long PCI8620_GATEMODE_POSITIVE_3	= 0x03;		// COUNTER:GATEߵƽʱ͵ƽʱֹͣʱдֵֵ
													// ڼOUTΪ10һڵ0װֵ

const long PCI8620_GATEMODE_POSITIVE_4	= 0x04;		// COUNTER:GATEߵƽʱ͵ƽʱֹͣʱдֵֵ
													// ѡͨдֵOUTΪ1 OUTһڵ͵ƽź

const long PCI8620_GATEMODE_RISING_5	= 0x05;		// COUNTER:GATEϱشгGATEװֵ
													// ӲѡͨдֵOUTΪ1 OUTһڵ͵ƽź

//***********************************************************
// CreateFileObjectõļʽ(ָͨʵֶַʽ)
const long PCI8620_modeRead					= 0x0000;	// ֻļʽ
const long PCI8620_modeWrite				= 0x0001;	// ֻдļʽ
const long PCI8620_modeReadWrite			= 0x0002;	// ȶдļʽ
const long PCI8620_modeCreate				= 0x1000;	// ļԴļڣؽļ0
const long PCI8620_typeText					= 0x4000;	// ıʽļ

//***********************************************************
// ûӿ
#ifndef _PCI8620_DRIVER_
#define DEVAPI __declspec(dllimport)
#else
#define DEVAPI __declspec(dllexport)
#endif

#ifdef __cplusplus
extern "C" {
#endif
	//######################## 豸 ##############################
	HANDLE DEVAPI FAR PASCAL PCI8620_CreateDevice(int DeviceLgcID = 0);     // ߼Ŵ豸
	HANDLE DEVAPI FAR PASCAL PCI8620_CreateDeviceEx(int DeviceID = 0);		// ID豸
	int DEVAPI FAR PASCAL PCI8620_GetDeviceCount(HANDLE hDevice); // ȡ豸̨
	BOOL DEVAPI FAR PASCAL PCI8620_GetDeviceCurrentID(HANDLE hDevice, PLONG DeviceLgcID, PLONG DevicePhysID);
	BOOL DEVAPI FAR PASCAL PCI8620_ListDeviceDlg(HANDLE hDevice); // ԶԻ巽ʽбϵͳееĸPCI豸
    BOOL DEVAPI FAR PASCAL PCI8620_ReleaseDevice(HANDLE hDevice); // ͷ豸

	//####################### ADݶȡ #################################
	// ڴͨûЩӿ򵥡ݡɿû֪豸
	// Ͳ㸴ӵӲЭͷƱ̣ĳʼ豸Ͷȡ
	// ADɸЧʵָ١ݲɼ

	// ADѯʽ
	BOOL DEVAPI FAR PASCAL PCI8620_InitDeviceProAD(			// ʼ豸TRUE,豸׼.
									HANDLE hDevice,			// 豸,CreateDevice
									PPCI8620_PARA_AD pADPara); // Ӳ, ڴ˺оӲ״̬

    BOOL DEVAPI FAR PASCAL PCI8620_StartDeviceProAD(		// ڳʼ֮豸
									HANDLE hDevice);		// 豸,CreateDevice

	BOOL DEVAPI FAR PASCAL PCI8620_ReadDeviceProAD_Npt(		// AD־Чʱô˺ȡ豸ϵAD(ǿշʽ)
									HANDLE hDevice,			// 豸,CreateDevice
									ULONG ADBuffer[],		// ԭʼADݵû
									LONG nReadSizeWords,	// ƫλݳ()
									PLONG nRetSizeWords);   // ʵʶȡĳ()

	BOOL DEVAPI FAR PASCAL PCI8620_GetDevStatusProAD(		// ADȡ豸ĸ״̬,ֵʾǷɹ
									HANDLE hDevice,			// 豸,CreateDevice
									PPCI8620_STATUS_AD pADStatus); // ADĸϢṹ

	BOOL DEVAPI FAR PASCAL PCI8620_ReadDeviceProAD_Half(	// AD־Чʱô˺ȡ豸ϵAD(ʽ)
									HANDLE hDevice,			// 豸,CreateDevice
									ULONG ADBuffer[],		// ԭʼADݵû
									LONG nReadSizeWords,	// ƫλݳ()
									PLONG nRetSizeWords);	// ʵʶȡĳ()
		
    BOOL DEVAPI FAR PASCAL PCI8620_StopDeviceProAD(			// 豸֮ͣ豸
									HANDLE hDevice);		// 豸,CreateDevice

	BOOL DEVAPI FAR PASCAL PCI8620_ReleaseDeviceProAD(		// رAD豸,ֹ,ͷԴ
									HANDLE hDevice);		// 豸,CreateDevice

	//##################### ADֱڴ(DMA)ʽ(ϲû) ###########################
	BOOL DEVAPI FAR PASCAL PCI8620_InitDeviceDmaAD(			// ʼ豸TRUE,豸׼.
									HANDLE hDevice,			// 豸,CreateDevice
									HANDLE hDmaEvent,		// DMA¼,CreateSystemEvent
									ULONG ADBuffer[],		// û,Ϊά
									ULONG nReadSizeWords,	// ÿDMAʱ,ûָӦȡʵʳ(ҪСڻnSegmentSizeWords)
									LONG nSegmentCount,		// ֶε,ȡֵΧΪ2-128
									ULONG nSegmentSizeWords,// ֶεĶγ(FIFO)
									PPCI8620_PARA_AD pADPara);	// Ӳ, ڴ˺оӲ״̬

	BOOL DEVAPI FAR PASCAL PCI8620_StartDeviceDmaAD(		// ڳʼ֮豸
									HANDLE hDevice);		// 豸,CreateDevice

	BOOL DEVAPI FAR PASCAL PCI8620_GetDevStatusDmaAD(		// ADȡDMAй״̬,ֵʾǷɹ
									HANDLE hDevice,			// 豸,CreateDevice
									PPCI8620_STATUS_DMA pDMAStatus); // õDMA״̬

	BOOL DEVAPI FAR PASCAL PCI8620_SetDevStatusDmaAD(		// ADDMAй״̬,ֵʾǷɹ
									HANDLE hDevice,			// 豸,CreateDevice
									LONG iClrBufferID);		// ҪĻID,Ϊ0

	BOOL DEVAPI FAR PASCAL PCI8620_StopDeviceDmaAD(			// 豸֮ͣ豸
									HANDLE hDevice);		// 豸,CreateDevice

	BOOL DEVAPI FAR PASCAL PCI8620_ReleaseDeviceDmaAD(		// رAD豸,ֹ,ͷԴ
									HANDLE hDevice);		// 豸,CreateDevice
	
	//##################### ADӲ ###########################
	BOOL DEVAPI FAR PASCAL PCI8620_SaveParaAD(HANDLE hDevice, PPCI8620_PARA_AD pADPara); // ǰADϵͳ
    BOOL DEVAPI FAR PASCAL PCI8620_LoadParaAD(HANDLE hDevice, PPCI8620_PARA_AD pADPara); // ADϵͳж
    BOOL DEVAPI FAR PASCAL PCI8620_ResetParaAD(HANDLE hDevice, PPCI8620_PARA_AD pADPara); // ADָĬֵ

	//####################### DA #################################
	// ڴͨûЩӿ򵥡ݡɿû֪豸
	// Ͳ㸴ӵӲЭͷƱ̣м
	// ʵDA
	BOOL DEVAPI FAR PASCAL PCI8620_WriteDeviceDA(			// дDA
									HANDLE hDevice,			// 豸,CreateDevice
									LONG OutputRange,		// ̣嶨οĳ岿
									SHORT nDAData,			// DAԭʼ[0, 4095]
									int nDAChannel);		// DAͨ[0-3]

	//####################### I/O #################################
	// ûʹWriteRegisterULongReadRegisterULongȺֱӿƼĴI/O
	// ʹʡ£ҪļĴλȣֻ
	// VBԵԲô򵥵ʵָͨĿơ
    BOOL DEVAPI FAR PASCAL PCI8620_SetDeviceDO(				// ״̬
										HANDLE hDevice,		// 豸								        
										BYTE bDOSts[16]);	// ״̬

	BOOL DEVAPI FAR PASCAL PCI8620_GetDeviceDI(				// ȡÿ״̬     
										HANDLE hDevice,		// 豸								        
										BYTE bDISts[16]);	// ״̬	

	BOOL DEVAPI FAR PASCAL PCI8620_RetDeviceDO(				// ȡÿ״̬     
										HANDLE hDevice,		// 豸								        
										BYTE bDOSts[16]);	// ״̬	
	
	//##################### ƺ ##########################
    BOOL DEVAPI FAR PASCAL PCI8620_SetDeviceCNT(			// ʼ
									HANDLE	hDevice,		// 豸
									ULONG	ContrlMode,		// ģʽ
									ULONG	CNTVal,			// ֵ
									ULONG	ulChannel);		// ͨѡ[0-2]			

	BOOL DEVAPI FAR PASCAL PCI8620_GetDeviceCNT(			// ȡø·ĵǰֵ
									HANDLE	hDevice,		// 豸,CreateDevice
									PULONG	pCNTVal,		// ؼֵ
									ULONG	ulChannel);		// ͨѡ[0-2]

	//################# ڴӳĴֱӲд ########################
	// ûԱ豸ֱӡ⡢Ͳ㡢ӵĿơ
	// ƶҪĿ̺ͿЧʱûʹЩӿʵ֡
	BOOL DEVAPI FAR PASCAL PCI8620_GetDeviceBar(			// ȡָָ豸ĴBARַ
									HANDLE hDevice,			// 豸,CreateDevice
									__int64  pbPCIBar[6]);	// PCI BARеַ,PCI BARжٿõַ뿴Ӳ˵

	BOOL DEVAPI FAR PASCAL PCI8620_GetDevVersion(			// ȡ豸̼汾
									HANDLE hDevice,			// 豸,CreateDevice
									PULONG pulFmwVersion,	// ̼汾
									PULONG pulDriverVersion);// 汾

    BOOL DEVAPI FAR PASCAL PCI8620_WriteRegisterByte(		// ָĴռλд뵥
									HANDLE hDevice,			// 豸,CreateDevice
									__int64 pbLinearAddr,	// ָĴԻַ,GetDeviceAddrеLinearAddrֵ
									ULONG OffsetBytes,		// Իַַƫλ(ֽ)
									BYTE Value);			// ַָд뵥ֽݣַԻַƫλþ

	BOOL DEVAPI FAR PASCAL PCI8620_WriteRegisterWord(		// д˫ֽݣͬϣ
									HANDLE hDevice, 
									__int64 pbLinearAddr, 
									ULONG OffsetBytes,  
									WORD Value);

	BOOL DEVAPI FAR PASCAL PCI8620_WriteRegisterULong(		// дĽݣͬϣ
									HANDLE hDevice, 
									__int64 pbLinearAddr, 
									ULONG OffsetBytes,  
									ULONG Value);

	BYTE DEVAPI FAR PASCAL PCI8620_ReadRegisterByte(		// 뵥ֽݣͬϣ
									HANDLE hDevice, 
									__int64 pbLinearAddr, 
									ULONG OffsetBytes);

	WORD DEVAPI FAR PASCAL PCI8620_ReadRegisterWord(		// ˫ֽݣͬϣ
									HANDLE hDevice, 
									__int64 pbLinearAddr, 
									ULONG OffsetBytes);

	ULONG DEVAPI FAR PASCAL PCI8620_ReadRegisterULong(		// ֽݣͬϣ
									HANDLE hDevice, 
									__int64 pbLinearAddr, 
									ULONG OffsetBytes);

	//################# I/O˿ֱӲд ########################
	// ûԱ豸ֱӡ⡢Ͳ㡢ӵĿơ
	// ƶҪĿ̺ͿЧʱûʹЩӿʵ֡
	// ЩҪڴͳ豸ISAߡڡڵ豸ڱPCI豸
    BOOL DEVAPI FAR PASCAL PCI8620_WritePortByte(			// 8λд˿
									HANDLE hDevice,			// 豸(CreateDevice)
									__int64 pbPort,			// ָĴַ
									ULONG OffsetBytes,		// ַƫλ(ֽ)
									BYTE Value);			// д8λ
    BOOL DEVAPI FAR PASCAL PCI8620_WritePortWord(HANDLE hDevice, __int64 pbPort, ULONG OffsetBytes, WORD Value);
    BOOL DEVAPI FAR PASCAL PCI8620_WritePortULong(HANDLE hDevice, __int64 pbPort, ULONG OffsetBytes, ULONG Value);

    BYTE DEVAPI FAR PASCAL PCI8620_ReadPortByte(HANDLE hDevice, __int64 pbPort, ULONG OffsetBytes);
    WORD DEVAPI FAR PASCAL PCI8620_ReadPortWord(HANDLE hDevice, __int64 pbPort, ULONG OffsetBytes);
    ULONG DEVAPI FAR PASCAL PCI8620_ReadPortULong(HANDLE hDevice, __int64 pbPort, ULONG OffsetBytes);
	// Ҫûģʽ£ֱӷӲ˿ڣ밲װʹISA\CommUserµReadPortByteExȺ
	//########################### ̲߳ ######################################
	HANDLE DEVAPI FAR PASCAL PCI8620_CreateSystemEvent(void); // ں¼󣬹InitDeviceDmaADVB̵߳Ⱥʹ
	BOOL DEVAPI FAR PASCAL PCI8620_ReleaseSystemEvent(HANDLE hEvent); // ͷں¼

#ifdef __cplusplus
}
#endif

#ifndef _FIFO_LENGTH_
#define _FIFO_LENGTH_
//***********************************************************
// FIFO洢ĳ()
const long FIFO_IDT7202_LENGTH			= 1024;
const long FIFO_IDT7203_LENGTH			= 2048;
const long FIFO_IDT7204_LENGTH			= 4096;
const long FIFO_IDT7205_LENGTH			= 8192;
const long FIFO_IDT7206_LENGTH			= 16384;
const long FIFO_IDT7207_LENGTH			= 32768;

#endif // _FIFO_LENGTH_

// Զ
#ifndef _PCI8620_DRIVER_
#ifndef _WIN64
#pragma comment(lib, "PCI8620_32.lib")
#pragma message("======== Welcome to use our art company's products!")
#pragma message("======== Automatically linking with PCI8620_32.dll...")
#pragma message("======== Successfully linked with PCI8620_32.dll")
#else
#pragma comment(lib, "PCI8620_64.lib")
#pragma message("======== Welcome to use our art company's products!")
#pragma message("======== Automatically linking with PCI8620_64.dll...")
#pragma message("======== Successfully linked with PCI8620_64.dll")
#endif
#endif // _PCI8620_DEVICE_

#endif // _PCI8620_DEVICE_